// Bernard Leclerc 03/2017

// Définition des pinuches de l'écran
#define TFT_PIN_CS   10 // Arduino-Pin an Display CS   
#define TFT_PIN_DC   9  // Arduino-Pin an A0
#define TFT_PIN_RST  8  // Arduino Reset-Pin

#include "Arduino.h"
#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"
#include <SPI.h>
#include <Adafruit_GFX.h>    // Adafruit Grafique Library
#include <Adafruit_ST7735.h> // Adafruit ST7735 Library

Adafruit_ST7735 tft = Adafruit_ST7735(TFT_PIN_CS, TFT_PIN_DC, TFT_PIN_RST);  // Display-Library Setup

// Declaration des entrees et des variables 
int relay = 7;
int led = 3;
int adv = 5;
int ok = 6;
int mn = 0;
int sk = 0;

// Declaration du port serie pour la synthese vocale 
SoftwareSerial mySoftwareSerial(4,2); // RX, TX
DFRobotDFPlayerMini myDFPlayer;


void setup()
{
digitalWrite(relay, HIGH); // Automaintien de l'alimentation par le relais
  analogWrite(led, 200);// Allume l'écran en PWM a 80%
    pinMode(adv, INPUT_PULLUP);// Attribut Bouton "Avance" avec résistance de tirage à vcc
  pinMode(ok, INPUT_PULLUP);// Attribut Bouton "OK"avec résistance de tirage à vcc
tft.initR(INITR_BLACKTAB);   // Initialisation ST7735-Chip
mySoftwareSerial.begin(9600);
   Serial.begin(115200);
  if (!myDFPlayer.begin(mySoftwareSerial)) {  //Use softwareSerial to communicate with mp3.
    while(true);
  }

//Reglage du volume et envoi du 1er message  
myDFPlayer.volume(25);  //Reglage du volume de 0 à 30
myDFPlayer.play(1);  //Envoi le premier message
}


void loop()
{
tft.fillScreen(ST7735_BLACK);// couleur du fond d'ecran
delay(200); // 0,2 secondes d'attente

//Ecriture du titre
tft.setTextSize(2);  // reglage grandeur de caracteres
  tft.setTextWrap(true); // Enveloppement Signature?
     tft.setCursor(24,4);  // Définir la position du texte
     tft.setTextColor(ST7735_WHITE);// couleur du texte
  tft.print("MINUTES");  // texte ecrit
delay(200); // 0,2 secondes d'attente

//Tracé de la ligne verte
tft.drawLine(10,24,118,24,ST7735_GREEN);// drawLine(x_start,y_start,x_end,y_end,couleur);

//Ecriture du Copyright  
tft.setTextSize(1);// Réglage nouvelle grandeur de caracteres
  tft.setTextColor(ST7735_GREEN);// Reglage Nouvelle couleur de text
    tft.setCursor(18,140);// Position du nouveau texte
      tft.print("bernard.leclerc");// Ecriture du texte première ligne
    tft.setCursor(30,148);// Position du nouveau texte seconde ligne
  tft.print("@wanadoo.fr");// Ecriture du texte seconde ligne
delay(200); // 0,2 secondes d'attente   

goto minutes;


// reglage des minutes à decompter 
minutes:
tft.setTextSize(5);  // reglage grandeur de caracteres
  tft.setTextWrap(true); // Enveloppement Signature?
      tft.setCursor(30,50);  // Définir la position du texte
     tft.setTextColor(ST7735_BLUE);// Couleur du texte
  tft.print(mn);// Variable de texte ecrit
delay(300); // 0,2 secondes d'attente

//Controle de l'état du bouton incrementation
   if (!digitalRead(adv)) { //Si le bouton est appuye
    mn = mn + 1; //Les minutes sont incrementees
      tft.fillRect(30,50,60,35,ST7735_BLACK); //et on efface la partie d'ecran pour preparer une nouvelle ecriture
  } 

//Controle de l'état du bouton validation
   if (!digitalRead(ok)) { //Si le bouton est appuye
    myDFPlayer.play(2);  //Envoi le second message
      tft.fillRect(30,50,60,35,ST7735_BLACK); //et on efface la partie d'ecran pour preparer une nouvelle ecriture
        tft.fillRect(24,4,100,15,ST7735_BLACK); // sur l'entete et la valeur
      tft.setTextSize(2);  // reglage grandeur des caracteres
    tft.setTextWrap(true); // Enveloppement Signature?
  tft.setCursor(18,4);  // Définir la position du texte
 tft.setTextColor(ST7735_WHITE);// Couleur du texte
tft.print("SECONDES");  // texte ecrit
   delay(300); // 0,2 secondes d'attente
    goto secondes; //Etape suivante
  } 
goto minutes;//On boucle jusqu'a action sur 'ok'



// reglage des secondes à decompter
secondes:
tft.setTextSize(5);  // reglage grandeur de caracteres
  tft.setTextWrap(true); // Enveloppement Signature?
      tft.setCursor(30,50);  // Définir la position du texte
    tft.setTextColor(ST7735_RED);// set couleur du texte
tft.print(sk);// variable du texte ecrit
  delay(300); // 0,2 secondes d'attente

//Controle de l'état du bouton incrementation
   if (!digitalRead(adv)) { //Si le bouton est appuye
    sk = sk + 5; // les secondes sont incrementé de 5 unitees
      tft.fillRect(30,50,60,35,ST7735_BLACK); //et on efface la partie d'ecran pour preparer une nouvelle ecriture
  }
// Si l'afichage des secondes depasse la minute
   if (sk > 59) {
    sk = 0; //on remet a zero
   }
   
//Controle de l'état du bouton validation
   if (!digitalRead(ok)){ //Si le bouton est appuye
      myDFPlayer.play(3);  //Envoi le troisième message
        tft.fillRect(30,50,60,35,ST7735_BLACK); //et on efface la partie d'ecran pour preparer une nouvelle ecriture
          tft.fillRect(4,4,130,15,ST7735_BLACK); // sur l'entete et la valeur
        tft.setTextSize(2);  // reglage grandeur caractère
      tft.setTextWrap(true); // Enveloppement Signature?
  tft.setCursor(40,4);  // Définir la position du texte
tft.setTextColor(ST7735_WHITE);// Couleur du texte
  tft.print("TIME");  // texte ecrit
    delay(300); // 0,2 secondes d'attente
    goto decompte; //Etape suivante
  } 
goto secondes; //On boucle jusqu'a action sur 'ok'


//Lancement du décompte 
decompte:
//affichage des minutes pour le décompte
tft.fillRect(40,40,60,80,ST7735_BLACK); //et on efface la partie d'ecran pour preparer une nouvelle ecriture
  tft.setTextSize(5);  // reglage grandeur de caracteres
    tft.setTextWrap(true); // Enveloppement Signature?
      tft.setCursor(40,40);  // Définir la position du texte
    tft.setTextColor(ST7735_BLUE);// Couleur du texte
  tft.print(mn);//texte ecrit
delay(200); // 0,2 secondes d'attente

//affichage des secondes pour le décompte
tft.setTextSize(5);  // reglage grandeur des caracteres
  tft.setTextWrap(true); // Enveloppement Signature?
    tft.setCursor(40,80);  // Définir la position du texte
      tft.setTextColor(ST7735_RED);// Couleur du texte
    tft.print(sk);//texte ecrit
  delay(790); // delay à ajuster XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//Décrementation du temps
sk = sk - 1; // On soustrait 1 seconde
if(mn<1 && sk<1) { // Le temps est écoule
  goto arret; 
}

if(sk < 1) { // Décrementation des minutes si les secondes sont écoulées
  sk = 59;   // Remise des secondes à 59
  mn = mn - 1;
}

// Gestion du rétroeclairage pour economiser la batterie
if(mn < 1) {
  analogWrite(led, 200);// Allume l'écran en PWM a 80%
}
else {
  analogWrite(led,55);// Reduit l'eclairage a 15% avant la dernière minute
}

//Arret forcé si les deux boutons sont appuyes simultanement
if (!digitalRead (adv) && !digitalRead (ok)) {
  digitalWrite(relay, LOW); // Coupure de l'alimentation  
}

goto decompte;


arret:
  myDFPlayer.play(4);  //Envoi le quatrième message
  delay (15000);
digitalWrite(relay, LOW); // Coupure de l'alimentation
      
}
